# redux-actions-assertions 
Assertions for redux actions testing.

This library adds assertions for [redux actions](http://redux.js.org/docs/advanced/AsyncActions.html) testing.  
It use [redux-mock-store](https://github.com/arnaudbenard/redux-mock-store) to mock redux store.

[![build status](https://img.shields.io/travis/redux-things/redux-actions-assertions/master.svg?style=flat-square)](https://travis-ci.org/redux-things/redux-actions-assertions)
[![npm version](https://img.shields.io/npm/v/redux-actions-assertions.svg?style=flat-square)](https://www.npmjs.com/package/redux-actions-assertions)

## Supported Assertion Frameworks/Libraries:
- [chai](https://redux-things.github.io/redux-actions-assertions/chai.html)
- [expect](https://redux-things.github.io/redux-actions-assertions/expect.html)
- [expect.js](https://redux-things.github.io/redux-actions-assertions/expectjs.html)
- [should](https://redux-things.github.io/redux-actions-assertions/should.html)
- [pure javascript assertion](https://redux-things.github.io/redux-actions-assertions/javascript.html)

If you have not found assertion framework/library that you are using - please add comment into [this issue](https://github.com/dmitry-zaets/redux-actions-assertions/issues/3).

## What it does:
- [Allows to avoid retesting nested action creators](https://redux-things.github.io/redux-actions-assertions/what_it_does.html#allows-to-avoid-retesting-nested-action-creators);
- [Reduces repetitive code of test methods](https://redux-things.github.io/redux-actions-assertions/what_it_does.html#reduces-repetitive-code-of-test-methods);
- [Simplifies initial setup](https://redux-things.github.io/redux-actions-assertions/what_it_does.html#simplifies-initial-setup);
